package com.fp.persistence.parmas.soli;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMSOLICITUDGUARDIAS*/
@Embeddable
public class TarmSolicitudGuardiasKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CSOLICITUD", nullable=false,updatable=false)

/**
* Codigo de solicitud de controld e armas
*/
private String csolicitud;

@Column(name="CEMPRESA", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer cempresa;

@Column(name="CGUARDIA", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer cguardia;

/**Contructor por defecto*/
public TarmSolicitudGuardiasKey(){}
/**Contructor de TarmSolicitudGuardiasKey
@param pCsolicitud Codigo de solicitud de controld e armas
@param pCempresa Codigo de persona
@param pCguardia Codigo de persona
*/
public TarmSolicitudGuardiasKey(String pCsolicitud,Integer pCempresa,Integer pCguardia){
 csolicitud=pCsolicitud;
 cempresa=pCempresa;
 cguardia=pCguardia;
}
/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de cempresa
@return valor de cempresa*/
public Integer getCempresa(){
  return cempresa;
}
/**Fija el valor de cempresa
@param pCempresa nuevo Valor de cempresa*/
public void setCempresa(Integer pCempresa){
  cempresa=pCempresa;
}

/**Obtiene el valor de cguardia
@return valor de cguardia*/
public Integer getCguardia(){
  return cguardia;
}
/**Fija el valor de cguardia
@param pCguardia nuevo Valor de cguardia*/
public void setCguardia(Integer pCguardia){
  cguardia=pCguardia;
}

/**Implementacion de la comparacion de TarmSolicitudGuardiasKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmSolicitudGuardiasKey))return false;
  TarmSolicitudGuardiasKey that = (TarmSolicitudGuardiasKey) o;
  if (this.getCsolicitud() == null || that.getCsolicitud() == null){
      return false;
  }
  if (! this.getCsolicitud().equals(that.getCsolicitud())){
    return false;
  }
  if (this.getCempresa() == null || that.getCempresa() == null){
      return false;
  }
  if (! this.getCempresa().equals(that.getCempresa())){
    return false;
  }
  if (this.getCguardia() == null || that.getCguardia() == null){
      return false;
  }
  if (! this.getCguardia().equals(that.getCguardia())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmSolicitudGuardiasKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCsolicitud() == null ? 0 : this.getCsolicitud().hashCode());
    result = result * 37 + (this.getCempresa() == null ? 0 : this.getCempresa().hashCode());
    result = result * 37 + (this.getCguardia() == null ? 0 : this.getCguardia().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
